#include <stdio.h>
#include <stdlib.h>

int p = 0;

void fill4(int n, int m, int arr[n][m], int x, int y, int fillcolor)
{
    if(x < n && x >= 0 && y < m && y >= 0)
    {
        //printf("asd");
       if(arr[x][y] == 0)
        {
            if(p == 0)
            {
                p = 1;
            }
            arr[x][y] = fillcolor;
            fill4(n,m,arr,x+1,y,fillcolor);
            fill4(n,m,arr,x-1,y,fillcolor);
            fill4(n,m,arr,x,y+1,fillcolor);
            fill4(n,m,arr,x,y-1,fillcolor);

        }
    }


}

int main()
{
    int n,m;
    int k;
    int x,y;
    int c = 2;
    scanf("%d %d %d", &n, &m, &k);
    int arr[n][m];

    for(int j=0; j<m; j++)
    {
        for(int i=0; i<n; i++)
        {
            arr[i][j] = 0;
        }
    }

    for(int i=0; i<k; i++)
    {
        scanf("%d %d", &x, &y);
        arr[x-1][y-1] = 1;
    }
    for(int j=0; j<m; j++)
    {
        for(int i=0; i<n; i++)
        {
            if(p == 0)
            {
                fill4(n,m,arr,i,j,c);
            }
            else if(p == 1)
            {
                p = 0;
                fill4(n,m,arr,i,j,c++);
            }

        }
    }
    printf("%d",c-1);

    /*for(int j=0; j<m; j++)
    {
        for(int i=0; i<n; i++)
        {
            printf("%d ",arr[i][j]);
        }
        printf("\n");
    }*/

    return 0;
}